﻿using System.Text.Json;
using Amazon.Lambda.APIGatewayEvents;
using MediatR;

namespace FunctionUrlWithMediatR;

public class DeleteRequest : IRequest<string>
{
    public DeleteRequest(APIGatewayHttpApiV2ProxyRequest incomingHttpRequest)
    {
        IncomingHttpRequest = incomingHttpRequest;
    }
    public APIGatewayHttpApiV2ProxyRequest IncomingHttpRequest { get; init; }
}

public class DeleteHandler : IRequestHandler<DeleteRequest, string>
{
    public Task<string> Handle(DeleteRequest request, CancellationToken cancellationToken)
    {
        return Task.FromResult($"You sent a DELETE request to {request.IncomingHttpRequest.RawPath}. The RequestId is {request.IncomingHttpRequest.RequestContext.RequestId}");
    }
}