﻿using System.Text.Json;
using Amazon.Lambda.APIGatewayEvents;
using MediatR;

namespace FunctionUrlWithMediatR;

public class PostRequest : IRequest<string>
{
    public PostRequest(APIGatewayHttpApiV2ProxyRequest incomingHttpRequest)
    {
        IncomingHttpRequest = incomingHttpRequest;
    }
    public APIGatewayHttpApiV2ProxyRequest IncomingHttpRequest { get; init; }
}

public class PostHandler : IRequestHandler<PostRequest, string>
{
    public Task<string> Handle(PostRequest request, CancellationToken cancellationToken)
    {
        return Task.FromResult($"You sent a POST request to {request.IncomingHttpRequest.RawPath}. Its body is {request.IncomingHttpRequest.Body}.");
    }
}