﻿using System.Text.Json;
using Amazon.Lambda.APIGatewayEvents;
using MediatR;

namespace FunctionUrlWithMediatR;

public class PutRequest : IRequest<string>
{
    public PutRequest(APIGatewayHttpApiV2ProxyRequest incomingHttpRequest)
    {
        IncomingHttpRequest = incomingHttpRequest;
    }
    public APIGatewayHttpApiV2ProxyRequest IncomingHttpRequest { get; init; }
}

public class PutHandler : IRequestHandler<PutRequest, string>
{
    public Task<string> Handle(PutRequest request, CancellationToken cancellationToken)
    {
        return Task.FromResult($"You sent a PUT request to {request.IncomingHttpRequest.RawPath}. Its body is {request.IncomingHttpRequest.Body.Length} bytes long.");
    }
}